<template>
  <div class="rui-tag">
    <div v-for="(nibble, index) in nibbles" :key="index" class="rui-tag__segment" :style="segmentStyle(index)">{{ nibble||'?' }}</div>
    <rui-button v-if="removable"
                icon="rui:x-bold"
                variant="destructive"
                class="rui-tag__delete-button"
                @click="remove" />
  </div>
</template>

<script>
import RuiButton from '../../Button/Button.vue'

/**
 * Displays a tag.
 *
 * This component handles composed tags, "a la Gitlab": a tag with `::` separators will be displayed as one tag with
 * multiple segments.
 *
 * @preset Default { "props": { "tag": "a tag" } }
 * @preset One segment { "props": { "tag": "blue::true" } }
 * @preset Two segments { "props": { "tag": "a::composed::tag" } }
 * @preset Three segments, colored { "props": { "tag": "a::super::composed::tag", "color": "#339933" } }
 */
export default {
  name: 'RuiTag',
  emits: [
    'remove',
  ],
  components: { RuiButton },
  props: {
    /** Tag name */
    tag: { required: true, type: String },
    /** Alternative value which will be emitted on remove */
    value: { required: false, type: [String, Number], default: null },
    /** Whether to display a "remove" button next to the tag */
    removable: { required: false, type: Boolean, default: false },
    /** Full hexadecimal opaque color to use as background (e.g.: #AABBCC, not #ABC, nor #AABBCCFF */
    color: { required: false, type: String, default: null },
  },
  computed: {
    nibbles () { return this.tag.split('::') },
    rgb () {
      if (!this.$props.color) return null

      return this.$props.color.match(/\w\w/g).map(x => parseInt(x, 16))
    },
    isLight () {
      if (!this.rgb) return

      return this.rgb[0] + this.rgb[1] + this.rgb[2] >= (255 * 3 / 2)
    },
  },
  methods: {
    remove () {
      const value = this.$props.value || this.$props.tag
      this.$emit('remove', value)
    },
    /**
     * Segment style based on its position
     *
     * @param   {number}      index - Segment index
     * @returns {string|null}       Style declaration
     */
    segmentStyle (index) {
      if (!this.rgb) return null
      return {
        'background-color': `rgba(${this.rgb[0]},${this.rgb[1]},${this.rgb[2]},${1 - (index / 4)})`,
        color: this.isLight ? '#111' : '#EEE',
      }
    },
  },
}
</script>
